<% . /usr/local/lib/cgi/haserl.sh ; check_instances uinetwork.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>

<html>
<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<title>Development Kit - Settings</title>
<link href="/sys/css/settings.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="/sys/js/util.js"></script>
<script type="text/javascript" src="/sys/js/visual.js"></script>
<script language="javascript">

var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
<% . /usr/local/www/current/cgi-bin/get_alsa.sh %>

var usb_cards = <% file=$(cfg_print_param usb_cards.general.json_file_path); if [ -f "$file" ]; then cat "$file"; else echo -n '""'; fi %>;

if ( usb_cards == ""){
	alert ('Could not detect USB card properties, the controls might not be available!');
	usb_cards = '{"usb_cards": [{}]}';
}

//fetch all usb_cards uci params
var uci_txt = "<% /usr/bin/uci -q show usb_cards | tr "\n" ","%>";
var uci_array = uci_txt.split(",");
//alert ("UCI Elements=" + uci_array.length);

/* password check */
function validatePassword(){
  	var password = document.getElementById("pwd_set");
	var password_chk = document.getElementById("pwd_chk");
	var ret=false;
  	if(password.value != password_chk.value) {
    	alert("Passwords don't match! Please correct them before submitting your changes!");
  	} else {
    	ret=true;
  	}
  	return ret;
}

/* hide html table row */
function hide_tr(id){
	el=document.getElementById(id);
	if (el) el.style.display='none';
}

/* show html table row
   Latest version of Firefox use "block" to show previously
   hidden table row when style.display='' is used in JS code
   This causes problems with select options drop down menus
   not being selectable with the mouse, so handle it
   it here differently here */
function show_tr(id){
       	el=document.getElementById(id);
	if (el){
		if (is_firefox){
			el.style.display='table-row';
            	}else{
			el.style.display='';
            	}
	}
}

/* local network params show function */

function view_network_settings(show_static){
        if (show_static == "static"){                                                         
	        show_tr('ip_addr');                                             
                show_tr('netmask');                                             
        	show_tr('gateway');                                             
                show_tr('dns1');                                                
                show_tr('dns2');                                                
                hide_tr('dhcp_name');                                           
        }else{                          
		hide_tr('ip_addr');                                             
		hide_tr('netmask');                                             
		hide_tr('gateway');                                             
		hide_tr('dns1');                                                
		hide_tr('dns2');                                                
		show_tr('dhcp_name');                                           
	}
}

/* switch between SERVER and CLIENT TCP view */
function view_tcp_tunnel_settings(tcp_mode){
    if (tcp_mode == "SERVER"){                                                         
		hide_tr('tcp_addr');                                                                                                               
    }else{                          
		show_tr('tcp_addr');
	}                                           
}

/* show/hide autoanswer timeout */
function showHideAutoanswerTimeout(enable){
    if (enable == "y"){                                                         
		show_tr('autoanswer_tmout');                                                                                                               
    }else{                          
		hide_tr('autoanswer_tmout');
	}                                           
}

function initConfigPage(){
	view_network_settings(document.getElementById('net_proto').value);
	view_tcp_tunnel_settings(document.getElementById('tcp_mode').value);
	// Show/Hide the AEC Tail
	var aecTypeElem=document.getElementById('aec_type');
	showHideAecTail(aecTypeElem.options[aecTypeElem.selectedIndex].value);
	showHideAutoanswerTimeout('<% cfg_print_param pjsua.misc.autoanswer %>');
	showMicLinein('<% cfg_print_param application.audio.mic_linein %>');
	showWebServerProtocol(<% cfg_print_param httpd.ssl.enabled %>);
	// populate the selection element for the available audio cards
	populateAlsaSelection(active_input,ALSA_INS,<% cfg_print_param usb_cards.general.default_input %>);
	populateAlsaSelection(active_output,ALSA_OUTS,<% cfg_print_param usb_cards.general.default_output %>);
	createUsbControls(usb_cards);
}

function showMicLinein(currSelection)
{
	if (currSelection == 'mic'){
		show_tr('mic_boost');
		show_tr('mic_gain');
		show_tr('ad_gain');
	}else{
		hide_tr('mic_boost');
		hide_tr('mic_gain');
		show_tr('ad_gain');
	}
}

function warnForHttps(elem){
	if (confirm ("!!! W A R N I N G !!!\nEnabling HTTPS will generate a self-signed certificate on the device. Some browsers may have problems loading sites with self-signed certificates. Make sure your browser supports that before enabling this option!"))
	{ 
		return true;
	}else{
		elem.value = false;
		elem.checked = false;
		document.getElementById('https_off').checked = true;
		return false;
	}
}

function showWebServerProtocol(value){
	var txt_value = String(value);
	if ( txt_value == "true" ) {
		// using HTTPS
		hide_tr('http_port');
		show_tr('ssl_port');
		show_tr('ssl_cert');
		show_tr('ssl_country');
		show_tr('ssl_prov');
		show_tr('ssl_loc');
		show_tr('ssl_orgname');
		show_tr('ssl_orgunit');
		show_tr('ssl_email');
		show_tr('ssl_cname');
		show_tr('ssl_regen');
	}else{
		// using HTTP
		show_tr('http_port');
		hide_tr('ssl_port');
		hide_tr('ssl_cert');
		hide_tr('ssl_country');
		hide_tr('ssl_prov');
		hide_tr('ssl_loc');
		hide_tr('ssl_orgname');
		hide_tr('ssl_orgunit');
		hide_tr('ssl_email');
		hide_tr('ssl_cname');
		hide_tr('ssl_regen');
	}
}

function checkIntInputValue(elem,minVal,maxVal,defVal)
{
	// get the entered value
	var newValue=elem.value;
	// if not set, use the default
	if ( newValue == "" ) newValue = defVal;
	// the value must be integer number
	var newValNum=parseInt(newValue, 10);
	// ... and in the range of min-max
	if ( newValNum > maxVal ) newValNum = maxVal;
	if ( newValNum < minVal ) newValNum = minVal;
	if ( newValue != newValNum ){
		elem.value = newValNum;
	}
}

function showHideAecTail(aecOpt)
{
	var tailElem=document.getElementById('aec_tail_row');
	if (aecOpt != "disabled"){
		tailElem.style.display = '';
	}else{
		tailElem.style.display = 'none';
	}
}

function showHideFdxOpts(fdxOpt)
{
	var fdxLevelElem=document.getElementById('hdx_levl');
	var fdxToutElem=document.getElementById('hdx_tout')
	if (fdxOpt == "y"){
		fdxLevelElem.style.display = '';
		fdxToutElem.style.display = '';
	}else{
		fdxLevelElem.style.display = 'none';
		fdxToutElem.style.display = 'none';
	}
}

function checkDTMF(elem)
{
	var dtmfString=elem.value;
	if (!/[*#0123456789]+$/.test(dtmfString)){
		alert('This is a non valid DTMF sequence! Please make sure that it contains only digits, and the "#*" characters!');
		elem.value=elem.defaultValue;
	}
}

function checkHostName(elem)
{
        var hostName=elem.value;
        if (!/^[-A-Za-z0-9\.]*$/.test(hostName)){
                alert('This is a non valid hostname! Characters from A to Z, from a to z, from 0 to 9, . and - only are admitted!');
                elem.value=elem.defaultValue;
        }
}

function populateAlsaSelection(selElem, array,current_device){
	var selected=false;
	var json_array=array; //JSON.parse(array);
	var arrayLength = Object.keys(json_array).length;
	if (arrayLength > 0){
		// if there is only one card, it must be the default one (0)
		if (arrayLength == 1 || current_device == "") current_device = 0;
		/*
		for (var i = 0; i < arrayLength; i++) {
			selected=current_device==i?true:false
			var optionName=json_array[i];
			i > 0?optionName = optionName + " (USB Card " + i +")":optionName = optionName + " (Internal Sound Card)"
			selElem.options[selElem.options.length]=new Option(optionName,i,false, selected);
		}*/
		var i = 0;
		for (var card_id in json_array) {
			var optionName=json_array[card_id];
			parseInt(card_id) > 0?optionName = optionName + " (USB Card " + card_id +")":optionName = optionName + " (Internal Sound Card)"
			current_device==parseInt(card_id)?selected=true:selected=false;
			selElem.options[selElem.options.length]=new Option(optionName,parseInt(card_id),false, selected);
			i++;
		}
	}
}
/*
Inserts a table row after the specified element, with two cells:
- cell 1: prints the name of the USB control
- cell 2: the cell where the select element is to be inserted
Params:
	- id of the table to inser t row into
	- id of the row after which the row is to be inserted
	- id to be assigned to the new row
	- USB control name to be pinted in cell 1
Returns: 
	- The ID of cell 2 to be passed as parameter to CreateElement function
*/
function insertTableRow(tableElemId,afterRowElem,newRowId, controlName)
{
	var table = document.getElementById(tableElemId);
	//console.log(table.rows.namedItem(afterRowElem)+1);
	var lastrow = table.rows.namedItem(afterRowElem);
	var row = table.insertRow(lastrow.rowIndex + 1);
	var td1 = row.insertCell(0);
	var td2 = row.insertCell(1);
	row.id = newRowId;
	td2.id = controlName;
	td1.innerHTML = controlName;
	return td2.id;
}

/*
Creates the webUI elements to control USB card(s)
audio properties
Params:
	- the JSON array with the USB cards, fetched from the device
Returns:
	- none
*/
function createUsbControls(cards_array)
{
	var numOfCards = parseInt(Object.keys(cards_array.usb_cards).length);
	for (var z in cards_array.usb_cards )
	{
		var usb_card=cards_array.usb_cards[z];
		var cardName=usb_card.name;
		var underscoredCardName = cardName.split(' ').join('_');
		for (var i in usb_card.controls ){
			var control = usb_card.controls[i];
			var cname = control.cname;
			var controlValueInUci = parseInt(getUciValue("usb_cards." + underscoredCardName+"." + cname));
		
			if ( control.volume_db != null || control.volume_pcent != null)
			{	
				var values = new Array();
				var currentSelection = 0;
				for(var k in control.volume_values )
				{
					//values[k] = control.volume_values[k.toString()];
					values[k] = createElement('option', control.volume_values[k.toString()], {value: k});
					var nonStringVal = parseFloat(control.volume_values[k.toString()].replace(/[^\d.-]/g, ''));
					if (isNaN(controlValueInUci)){
						if ((nonStringVal == parseFloat(control.volume_db)) || (nonStringVal == parseFloat(control.volume_pcent))){
							currentSelection = k;
						} 
					}else{
						if (k == controlValueInUci) currentSelection = k;					
					}
				}
				var rowElemId = "usb_audio"+i;
				var nextRowId = "usb_audio"+parseInt(i+1);
				var sel_td_id = insertTableRow("t4", rowElemId, nextRowId, cname + " ("+cardName+")");
				var selectUciName = "usb_cards."+underscoredCardName + "." + cname;
				//alert (selectUciName);
				var newSelectElem = createElement('select', null, // 'select' = name of element to create, null = no text to insert
			{name: selectUciName}, 	// Attributes to attach
			values, 				// append all elements
			sel_td_id 				// append final element to body - this also takes a element by id
		);
				// preselect the correct index
				newSelectElem.selectedIndex = currentSelection;
			}
		}
	}
	// show the USB rows only if available
	numOfCards > 0?show_tr("usb_audio0"):hide_tr("usb_audio0");		
}

/*
Generic THML element factory. Creates the element, and returns a ref to it
Params:
	- Element type (ex. "select"
	- Text to be inserted
	- Array of attributes to be added (ex. {id=test, name=test_name, ...}
	- Array of children to be appended (ex options for select)
	- Target to be appended to. "body" by default, or the ID of the element
	to be appended to
Returns:
	- reference to the new element

*/

function createElement(){
    var element  = document.createElement(arguments[0]),
        text     = arguments[1],
        attr     = arguments[2],
        append   = arguments[3],
        appendTo = arguments[4];

    for(var key = 0; key < Object.keys(attr).length ; key++){
        var name = Object.keys(attr)[key],
             value = attr[name],
             tempAttr = document.createAttribute(name);
             tempAttr.value = value;
        element.setAttributeNode(tempAttr)
    }

    if(append){
        for(var _key = 0; _key < append.length; _key++) {
            element.appendChild(append[_key]);
        }
    }

    if(text) element.appendChild(document.createTextNode(text));

    if(appendTo){
        var target = appendTo === 'body' ? document.body : document.getElementById(appendTo);
        target.appendChild(element);
    }       

    return element;
}

function getUciValue(uciKey){
	var uciValue="";
	for (i=0; i < uci_array.length; i++){
		var tmpLine = uci_array[i].split("=");
		uciValue="";
		if (tmpLine[0] == uciKey){
			uciValue = tmpLine[1].replace("'","");
			break;
		}
	}
	return uciValue;
}

function playBeep(){
	player = document.getElementById('player');
	beep_name = document.getElementById('beep_name').value;
	beep_path = "/sounds/" + beep_name;
	player.setAttribute('src', beep_path);
	player.load();
	player.play();
}



</script>
<style type="text/css">
<!--
body { margin-left:20px }
table {
	width:600px;
	border-spacing:5px;
}
-->
</style>
</head>
<body onload="initConfigPage();show_cfg(1);">

<form name="settings" action=config.cgi method=POST>
<input type=hidden name=return_page value=cgi-bin/uiadvanced.cgi>
<audio id=player style="display:none" controls><source src="/sounds/beep1.wav"></audio>

<table id="t1" cellspacing=5 width="510px">    
    <col style="width:120px">                                                
    <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>SIP ACCOUNT SETTINGS</b></td>
	</tr>
	
	<tr>
	    <td><font size=2><b>SIP Server(PBX)</b></font></td>
		<td>
			<input  name="pjsua.sip_account.registrar" size="16" maxlength="50" value="<% cfg_print_param pjsua.sip_account.registrar %>" onChange="StringCheck(this)">
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>SIP User Name</b></font></td>
		<td>
			<input  name="pjsua.sip_account.username" size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.username %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>Auth User Name</b></font></td>
		<td>
			<input  name="pjsua.sip_account.authname" size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.authname %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>SIP/Auth User Password</b></font></td>
		<td>
			<input  name="pjsua.sip_account.password" type=password size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.password %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>Outbound Proxy</b></font></td>
		<td>
			<input  name="pjsua.sip_account.proxy" size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.proxy %>"
                >
        </td>
    </tr>
    
    <tr>
		<td><font size=2><b>Registration Timeout</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.sip_account.reg_to" 
					size="5" maxlength="5" 
					value="<% cfg_print_param pjsua.sip_account.reg_to %>"
					onchange="checkIntInputValue(this,60,3600,600);"
				>&nbsp;s
			</font>
		</td>
	</tr>
	
	<tr>
		<td><font size=2><b>RTP Stream Timeout</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.rtp_stream_timeout" 
					size="5" maxlength="4" 
					value="<% cfg_print_param pjsua.misc.rtp_stream_timeout %>"
					onchange="checkIntInputValue(this,0,3600,10);"
				>&nbsp;s
			</font>
		</td>
	</tr>
	
	
	<tr>
		<td><font size=2><b>Autodetect NAT</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.misc.update_nat"
				value="y" <% if cfg_string_compare pjsua.misc.update_nat y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.misc.update_nat"
				value="n" <% if ! cfg_string_compare pjsua.misc.update_nat y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	
	<tr>
		<td><font size=2><b>Autoanswer Incoming Call</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.misc.autoanswer"
				value="y" <% if cfg_string_compare pjsua.misc.autoanswer y ; then echo -n "checked"; fi %>
				onchange="showHideAutoanswerTimeout(this.value);"
				>On
			<input type="radio" name="pjsua.misc.autoanswer"
				value="n" <% if ! cfg_string_compare pjsua.misc.autoanswer y ; then echo -n "checked"; fi %>
				onchange="showHideAutoanswerTimeout(this.value);"
				>Off
		</font>
	</tr>
	<tr id="autoanswer_tmout">
		<td><font size=2><b>Autoanswer Timeout</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.autoanswer_timer" 
					size="5" maxlength="3" 
					value="<% val=$(cfg_print_param pjsua.misc.autoanswer_timer); if [ "$val" == "" ]; then val=0; fi; echo "$val" %>"
					onchange="checkIntInputValue(this,0,100,0);"
				>&nbsp;s
			</font>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Play Beep on Call Answer</b></font></td>
		<td>
			<select size="1" width="140px" name="pjsua.misc.beep_on">
				<option value="0" <% val=`cfg_print_param pjsua.misc.beep_on`; if [ $val -ne 1 ] || [ $val -ne 2 ] ; then echo -n " selected"; fi %>>Disabled</option>
				<option value="1" <% val=`cfg_print_param pjsua.misc.beep_on`; if [ $val == "1" ] ; then echo -n " selected"; fi %>>Play on remote peer</option>
				<option value="2" <% val=`cfg_print_param pjsua.misc.beep_on`; if [ $val == "2" ] ; then echo -n " selected"; fi %>>Play also locally</option>        
			</select>
		</td>
	<tr>
		<td><font size=2><b>Beep Tone</b></font></td>
		<td>
			<select size="1" width="140px" name="pjsua.misc.beep_name" id=beep_name >
				<option value="beep1.wav" <% val=`cfg_print_param pjsua.misc.beep_name`; if [ $val != "beep2.wav" ] || [ $val != "beep3.wav" ]; then echo -n " selected"; fi %>>Long Chime</option>
				<option value="beep3.wav" <% val=`cfg_print_param pjsua.misc.beep_name`; if [ $val == "beep3.wav" ] ; then echo -n " selected"; fi %>>Short Chime</option>
				<option value="beep2.wav" <% val=`cfg_print_param pjsua.misc.beep_name`; if [ $val == "beep2.wav" ] ; then echo -n " selected"; fi %>>Simple Beep</option>
				<% if ! [ -s "/usr/local/www/current/sounds/beep4.wav" ] ; then echo -n "<!--"; fi %>
				<option value="beep4.wav" <% val=`cfg_print_param pjsua.misc.beep_name`; if [ $val == "beep4.wav" ] ; then echo -n " selected"; fi %>>Custom Beep</option>
				<% if ! [ -s "/usr/local/www/current/sounds/beep4.wav" ] ; then echo -n "-->"; fi %>
			</select>
			<input type="button" value="Play Beep" onclick="playBeep();">
			<input type="button" value="Upload Custom Beep" onclick="javascript:window.open('/uifbeeploader.html','_parent');">
			<!--
			<a href=/uifbeeploader.html target=_parent>Upload Custom Beep</a>
			-->

		</td>
	<tr>
		<td><font size=2><b>Autodial</b></font></td>
		<td>
			<select size="1" width="140px" name="pjsua.misc.autodial_on_boot">
				<option value="0" <% val=`cfg_print_param pjsua.misc.autodial_on_boot`; if [ $val -ne 1 ] || [ $val -ne 2 ] ; then echo -n " selected"; fi %>>Disabled</option>
				<option value="1" <% val=`cfg_print_param pjsua.misc.autodial_on_boot`; if [ $val == "1" ] ; then echo -n " selected"; fi %>>On start/boot</option>
				<option value="2" <% val=`cfg_print_param pjsua.misc.autodial_on_boot`; if [ $val == "2" ] ; then echo -n " selected"; fi %>>On call close/drop</option>        
			</select>
		</td>
<!--		<td><font size=2>
			<input type="radio" name="pjsua.misc.autodial_on_boot"
				value="y" <% if cfg_string_compare pjsua.misc.autodial_on_boot y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.misc.autodial_on_boot"
				value="n" <% if ! cfg_string_compare pjsua.misc.autodial_on_boot y ; then echo -n "checked"; fi %>>Off
		</font>
	-->
	</tr>
	<tr>
		<td><font size=2><b>Call On Input ID</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.quick_dial_num" 
					size="20" maxlength="60" 
					value="<% cfg_print_param pjsua.misc.quick_dial_num %>"
				>
			</font>
		</td>
	</tr>

	<tr>
		<td><font size=2><b>DTMF Pattern</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.dtmf_pattern" 
					size="5" maxlength="5" 
					value="<% cfg_print_param pjsua.misc.dtmf_pattern %>"
					onChange=checkDTMF(this)
				>
			</font>
		</td>
	</tr>
</table>

<table id="t2" cellspacing=5 width="510px">
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>SIP CODECS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>G.711 (uLaw)</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.ulaw"
				value="y" <% if cfg_string_compare pjsua.codecs.ulaw y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.ulaw"
				value="n" <% if ! cfg_string_compare pjsua.codecs.ulaw y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>G.711 (aLaw)</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.alaw"
				value="y" <% if cfg_string_compare pjsua.codecs.alaw y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.alaw"
				value="n" <% if ! cfg_string_compare pjsua.codecs.alaw y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>Speex</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.speex"
				value="y" <% if cfg_string_compare pjsua.codecs.speex y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.speex"
				value="n" <% if ! cfg_string_compare pjsua.codecs.speex y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>GSM</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.gsm"
				value="y" <% if cfg_string_compare pjsua.codecs.gsm y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.gsm"
				value="n" <% if ! cfg_string_compare pjsua.codecs.gsm y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>G.722</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.g722"
				value="y" <% if cfg_string_compare pjsua.codecs.g722 y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.g722"
				value="n" <% if ! cfg_string_compare pjsua.codecs.g722 y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>iLBC</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.ilbc"
				value="y" <% if cfg_string_compare pjsua.codecs.ilbc y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.ilbc"
				value="n" <% if ! cfg_string_compare pjsua.codecs.ilbc y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
	<tr>
		<td><font size=2><b>OPUS</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.opus"
				value="y" <% if cfg_string_compare pjsua.codecs.opus y ; then echo -n "checked"; fi %>>On
			<input type="radio" name="pjsua.codecs.opus"
				value="n" <% if ! cfg_string_compare pjsua.codecs.opus y ; then echo -n "checked"; fi %>>Off
		</font>
	</tr>
</table>


<table id="t3" cellspacing=5 width="510px">    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>SIMPLE PLAYER SETTINGS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>Play MP3 File/Stream</b></font></td>
        <td><font size=2>
        	<input type="radio" name="simple_player.common.media_type"
        		value="files"
       <%  if cfg_string_compare simple_player.common.media_type files ; then echo -n "checked"; fi %>>Files
       		<input type="radio" name="simple_player.common.media_type"
        		value="stream"
       <% if cfg_string_compare simple_player.common.media_type stream ; then echo -n "checked"; fi %>>Stream
		</font>
        </td>
	</tr>
    <tr>
	    <td><font size=2><b>Media Folder Name</b></font></td>
		<td>
			<input  name="simple_player.files.media_folder" 
					size="16" maxlength="50" 
                    value="<% cfg_print_param simple_player.files.media_folder %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>Stream URL</b></font></td>
		<td>
			<input  name="simple_player.streaming.url"
					size="65" maxlength="80" 
                    value="<% cfg_print_param simple_player.streaming.url%>"
                >
        </td>
    </tr>
    <tr>
    <td><font size=2><b>RTP Stream Buffer</b></font></td>
   	<td>
        <font size=2>
            <input name="simple_player.streaming.buffer_ms" 
                size="5" maxlength="5" 
                value="<% cfg_print_param simple_player.streaming.buffer_ms %>"
                onchange="checkIntInputValue(this,10,1000,300);"
            >&nbsp;ms
        </font>
    </td>
</tr>
	    
</table>

<table id="t4" cellspacing=5 width="510px">
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>AUDIO SETTINGS</b></td>
	</tr>
		
	<tr>
		<td><font size=2><b>Audio Input Device</b></font></td>
		<td>	
			<select size=1 id=active_input name=usb_cards.general.default_input>
				
			</select>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Audio Output Device</b></font></td>
		<td>	
			<select size=1 id=active_output name=usb_cards.general.default_output>
				
			</select>
		</td>
	</tr>
	
	<tr>
		<td colspan="2"><br><b>INTERNAL AUDIO CARD SETTINGS</b></td>
	</tr>
	<tr>
	    <td><font size=2><b>Volume</b></font></td>
		<td>
			<input  name="application.audio.volume" 
					size="3" maxlength="3" 
                    value="<% cfg_print_param application.audio.volume %>"
                    onchange="checkIntInputValue(this,0,100,50);"
                >&nbsp;%
        </td>
    </tr>
<!-- This disables audio, and is automatically controlled by the alsa 
	 restore scripts and the application to avoid clicks. 
	 Do not expose to the user!
	<tr>
		<td><font size=2><b>Audio Amplifier</b></font></td>
        <td><font size=2>
        	<input type="radio" name="application.audio.amplifier"
        		value="on"
       <% if cfg_string_compare application.audio.amplifier on ; then echo -n "checked"; fi %>>On
       		<input type="radio" name="application.audio.amplifier"
        		value="off"
       <% if cfg_string_compare application.audio.amplifier off ; then echo -n "checked"; fi %>>Off
		</font>
        </td>
	</tr>
-->
	<tr>
		<td><font size=2><b>Mic/Line-in</b></font></td>
        <td><font size=2>
        	<input type="radio" name="application.audio.mic_linein"
        		value="mic"
        		onclick=showMicLinein(this.value);
       <% if cfg_string_compare application.audio.mic_linein mic ; then echo -n "checked"; fi %>>Mic
       		<input type="radio" name="application.audio.mic_linein"
        		value="line"
        		onclick=showMicLinein(this.value);
       <% if cfg_string_compare application.audio.mic_linein line ; then echo -n "checked"; fi %>>Line In
		</font>
        </td>
	</tr>
<!--  Mic boost is automatically set when mic is selected, and off-for line in
	  Do not expose to the user
	<tr id=mic_boost>
	    <td><font size=2><b>Microphone Boost</b></font></td>
		<td>
			<input  type=radio name="application.audio.mic_boost" 
					value="on"
       <% if cfg_string_compare application.audio.mic_boost on ; then echo -n "checked"; fi %>>On
			<input  type=radio name="application.audio.mic_boost" 
					value="off"
       <% if cfg_string_compare application.audio.mic_boost off ; then echo -n "checked"; fi %>>Off
        </td>
    </tr>
-->
   	<tr id=mic_gain>
		<td><font size=2><b>Microphone Gain</b></font></td>
        <td><select size="1" width="140px" name="application.audio.mic_gain">
            <option value="0dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "0dB" ] ; then echo -n " selected"; fi %>>0dB</option>
            <option value="24dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "24dB" ] ; then echo -n " selected"; fi %>>24dB</option>
            <option value="27dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "27dB" ] ; then echo -n " selected"; fi %>>27dB</option>
            <option value="30dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "30dB" ] ; then echo -n " selected"; fi %>>30dB</option>
            <option value="33dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "33dB" ] ; then echo -n " selected"; fi %>>33dB</option>
            <option value="36dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "36dB" ] ; then echo -n " selected"; fi %>>36dB</option>
            <option value="39dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "39dB" ] ; then echo -n " selected"; fi %>>39dB</option>
            <option value="42dB" <% val=`cfg_print_param application.audio.mic_gain`; if [ $val = "42dB" ] ; then echo -n " selected"; fi %>>42dB</option>
         </td>
	</tr>
   	<tr id=ad_gain>
		<td><font size=2><b>A/D Amplifier Gain</b></font></td>
        <td><select size="1" width="140px" name="application.audio.ad_gain">
            <option value="-4.5dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = ".4.5dB" ] ; then echo -n " selected"; fi %>>-4.5dB</option>
            <option value="-3.0dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "-3.0dB" ] ; then echo -n " selected"; fi %>>-3.0dB</option>
            <option value="-1.5dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "-1.5dB" ] ; then echo -n " selected"; fi %>>-1.5dB</option>
            <option value="0dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "0dB" ] ; then echo -n " selected"; fi %>>0dB</option>
            <option value="1.5dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "1.5dB" ] ; then echo -n " selected"; fi %>>1.5dB</option>
            <option value="3.0dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "3.0dB" ] ; then echo -n " selected"; fi %>>3.0dB</option>
            <option value="4.5dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "4.5dB" ] ; then echo -n " selected"; fi %>>4.5dB</option>
            <option value="6.0dB" <% val=`cfg_print_param application.audio.ad_gain`; if [ $val = "6.0dB" ] ; then echo -n " selected"; fi %>>6.0dB</option>
         </td>
	</tr>
	
	       
    <tr>
        <td><font size=2><b>AEC</b></font></td>
        <td>
            <font size=2>
                <select size="1" id=aec_type name="pjsua.aec.ec_opt" onchange="showHideAecTail(this.value);">
                    <option value="disabled" <% if cfg_string_compare pjsua.aec.ec_opt disabled; then echo -n "selected"; fi %>>Disabled</option>
                    <option value="speex" <% if cfg_string_compare pjsua.aec.ec_opt speex; then echo -n "selected"; fi %>>SPEEX</option>
					<!--
                   	<option value="suppressor" <% if cfg_string_compare pjsua.aec.ec_opt suppressor; then echo -n "selected"; fi %>>Suppressor</option>
                   	-->
                </select>
            </font>
        </td>
	</tr>
	
	
	<tr id=usb_audio0>
		<td colspan="2"><br><b>USB AUDIO SETTINGS</b></td>
	</tr>
	
	<tr>
		<td colspan="2"><br><b>SIP AUDIO SETTINGS</b></td>
	</tr>

	<tr id=aec_tail_row>
		<td><font size=2><b>AEC Tail</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.aec.ec_tail" 
					id=aec_tail_val
					size="5" maxlength="5" 
					value="<% cfg_print_param pjsua.aec.ec_tail %>"
					onchange="checkIntInputValue(this,1,1000,250);"
				>&nbsp;ms
			</font>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>VAD</b></font></td>
        <td><font size=2>
        	<input type="radio" name="pjsua.aec.no_vad"
        		value="n"
       <%  if cfg_string_compare pjsua.aec.no_vad n ; then echo -n "checked"; fi %>>Enable
       		<input type="radio" name="pjsua.aec.no_vad"
        		value="y"
       <% if cfg_string_compare pjsua.aec.no_vad y ; then echo -n "checked"; fi %>>Disable
		</font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Audio Mode</b></font></td>
        <td><font size=2>
        	<input type="radio" name="pjsua.misc.half_duplex"
        		value="n" <% if cfg_string_compare pjsua.misc.half_duplex n ; then echo -n "checked"; fi %> onclick="showHideFdxOpts(this.value);">Full Duplex
       		<input type="radio" name="pjsua.misc.half_duplex"
        		value="y" <% if cfg_string_compare pjsua.misc.half_duplex y ; then echo -n "checked"; fi %>  onclick="showHideFdxOpts(this.value);">Half Duplex
		</font>
        </td>
	</tr>
	<tr id="hdx_levl" <% if cfg_string_compare  pjsua.misc.half_duplex n; then echo -n ' style="display:none"'; fi %>>
		<td><font size=2><b>HDX Trigger Level</b></font></td>
        <td><font size=2>
        	<input size="5" maxlength="3" name="pjsua.misc.half_duplex_db"
        		value="<% cfg_print_param pjsua.misc.half_duplex_db %>"
        		onchange="checkIntInputValue(this,-60,0,-40);"
        		>&nbsp;dB
       		</font>
        </td>
	</tr>
	<tr id="hdx_tout" <% if cfg_string_compare  pjsua.misc.half_duplex n; then echo -n 'style="display:none"'; fi %>>
		<td><font size=2><b>HDX Trigger Timeout</b></font></td>
        <td><font size=2>
        	<input size="5" maxlength="4" name="pjsua.misc.half_duplex_tout"
        		value="<% cfg_print_param pjsua.misc.half_duplex_tout %>"
        		onchange="checkIntInputValue(this,0,2000,250);"
        		>&nbsp;ms
       		</font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Mic/Line-in Latency</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.capture_lat" 
					size="5" maxlength="5" 
					value="<% cfg_print_param pjsua.misc.capture_lat %>"
					onchange="checkIntInputValue(this,0,1000,100);"
				>&nbsp;ms
			</font>
		</td>
	</tr>

	<tr>
		<td><font size=2><b>Playback Latency</b></font></td>
		<td>
			<font size=2>
				<input name="pjsua.misc.playback_lat" 
					size="5" maxlength="5" 
					value="<% cfg_print_param pjsua.misc.playback_lat %>"
					onchange="checkIntInputValue(this,0,1000,100);"
				>&nbsp;ms
			</font>
		</td>
	</tr>

	<tr>
		<td><font size=2><b>Audio Channels</b></font></td>
		<td><font size=2>
			<input type="radio" name="pjsua.codecs.stereo"
				value="y" <% if cfg_string_compare pjsua.codecs.stereo y ; then echo -n "checked"; fi %>>Stereo
			<input type="radio" name="pjsua.codecs.stereo"
				value="n" <% if ! cfg_string_compare pjsua.codecs.stereo y ; then echo -n "checked"; fi %>>Mono
		</font>
	</tr>

</table>

<table id="t5" cellspacing=5 width="510px">
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>NETWORK SETTINGS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>Use Avahi discovery</b></font></td>
        <td><font size=2><% form_print_radio network.avahi.enabled Yes No %> </font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Use SonicIP</b></font></td>
        <td><font size=2><% form_print_radio network.sonic_ip.enabled Yes No %> </font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>SonicIP Volume</b></font></td>
        <td><select size="1" width="140px" id="sonicc_vol" name="network.sonic_ip.volume">
            <option value="0%" <% if cfg_string_compare network.sonic_ip.volume 0% ; then echo -n "selected"; fi %>>0 %</option>
            <option value="10%" <% if cfg_string_compare network.sonic_ip.volume 10% ; then echo -n "selected"; fi %>>10 %</option>
            <option value="20%" <% if cfg_string_compare network.sonic_ip.volume 20% ; then echo -n "selected"; fi %>>20 %</option>
            <option value="30%" <% if cfg_string_compare network.sonic_ip.volume 30% ; then echo -n "selected"; fi %>>30 %</option>
            <option value="40%" <% if cfg_string_compare network.sonic_ip.volume 40% ; then echo -n "selected"; fi %>>40 %</option>
            <option value="50%" <% if cfg_string_compare network.sonic_ip.volume 50% ; then echo -n "selected"; fi %>>50 %</option>
            <option value="60%" <% if cfg_string_compare network.sonic_ip.volume 60% ; then echo -n "selected"; fi %>>60 %</option>
            <option value="70%" <% if cfg_string_compare network.sonic_ip.volume 70% ; then echo -n "selected"; fi %>>70 %</option>
            <option value="80%" <% if cfg_string_compare network.sonic_ip.volume 80% ; then echo -n "selected"; fi %>>80 %</option>
            <option value="90%" <% if cfg_string_compare network.sonic_ip.volume 90% ; then echo -n "selected"; fi %>>90 %</option>
            <option value="100%" <% if cfg_string_compare network.sonic_ip.volume 100% ; then echo -n "selected"; fi %>>100 %</option>
         </td>
	</tr>
	<tr>
		<td><font size=2><b>Protocol</b></font></td>
		<td>
			<select size="1" width="140px" id="net_proto" name="network.eth0.proto" onchange="view_network_settings(this.value)">
				<option value="dhcp" <% if cfg_string_compare network.eth0.proto dhcp ; then echo -n "selected"; fi %>>DHCP</option>
				<option value="static" <% if cfg_string_compare network.eth0.proto static ; then echo -n "selected"; fi %>>Static</option>
			</select>
			</td>
	</tr>		
	<tr id="ip_addr" >
		<td><font size=2><b>IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.ipaddr" size="16" maxlength="15" value="<% cfg_print_param network.eth0.ipaddr %>" onChange="IPAddrCheck(this,0)"></font></td>
	</tr>
	<tr id="netmask" >
		<td><font size=2><b>Netmask</b></font></td>
		<td><font size=2><input name="network.eth0.netmask" size="16" maxlength="15" value="<% cfg_print_param network.eth0.netmask %>" onChange="NetmaskCheck(this)"></font>
        </td>
	</tr>
	<tr id="gateway" >
		<td><font size=2><b>Gateway IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.gateway" size="16" maxlength="15" value="<% cfg_print_param network.eth0.gateway %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns1" >
		<td><font size=2><b>Primary DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns1" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns1 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns2" >
		<td><font size=2><b>Alternative&nbsp;DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns2" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns2 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dhcp_name">
		<td><font size=2><b>DHCP Host Name</b></font></td>
		<td>
		     <input name="network.eth0.dhcpname" size="20" maxlength="32" value="<% cfg_print_param network.eth0.dhcpname %>" onChange="checkHostName(this)">
        </td>
	</tr>
	<tr id="syslog_addr">
		<td><font size=2><b>Syslog Address</b></font></td>
		<td><font size=2><input name="syslogd.remote.ipaddr" size="16" maxlength="15" value="<% cfg_print_param syslogd.remote.ipaddr %>" onChange="IPAddrCheck(this,1)"></font></td>
	</tr>
	
	<tr>
		<td colspan="2"><br><b>WEB SERVER SETTINGS</b><br></td>
	</tr>
	<tr>
		<td><font size=2><b>Web Server Protocol</b></font></td>
		<td><font size=2>
			<input type="radio" id=https_on name="httpd.ssl.enabled" value=true
				onclick="if (warnForHttps(this) == true) {showWebServerProtocol(this.value);}else{this.value = false;this.checked = false;}"
				<% if cfg_string_compare httpd.ssl.enabled true ; then echo -n "checked"; fi %>>HTTPS
			<input type="radio" id=https_off name="httpd.ssl.enabled" value=false
				onclick="showWebServerProtocol(this.value)"
				<% if ! cfg_string_compare httpd.ssl.enabled true ; then echo -n "checked"; fi %>>HTTP
			</font>
		</td>
	</tr>
	<tr id="http_port">
		<td><font size=2><b>HTTP Server Port</b></font></td>
		<td>
			<input name="httpd.webserver.port" size="5" maxlength="5" value="<% cfg_print_param httpd.webserver.port %>" onChange="PortCheck(this,1)">
		</td>
	</tr>
	<tr id="ssl_port">
		<td><font size=2><b>HTTPS Server Port</b></font></td>
		<td>
		     <input name="httpd.ssl.port" size="5" maxlength="5" value="<% cfg_print_param httpd.ssl.port %>" onChange="PortCheck(this,1)">
        </td>
	</tr>
	<tr id="ssl_cert">
		<td colspan="2"><br><b>SSL Certificate Settings</b><br></td>
	</tr>
	<tr id="ssl_country">
		<td><font size=2><b>Country</b></font></td>
		<td>
			<input name="httpd.ssl.country" size="5" maxlength="2" value="<% cfg_print_param httpd.ssl.country %>">
		</td>
	</tr>
	<tr id="ssl_prov">
		<td><font size=2><b>Province</b></font></td>
		<td>
			<input name="httpd.ssl.province" size="15" maxlength="20" value="<% cfg_print_param httpd.ssl.province %>">
		</td>
	</tr>
	<tr id="ssl_loc">
		<td><font size=2><b>Locality</b></font></td>
		<td>
			<input name="httpd.ssl.locality" size="15" maxlength="20" value="<% cfg_print_param httpd.ssl.locality %>">
		</td>
	</tr>
	<tr id="ssl_orgname">
		<td><font size=2><b>Organisation Name</b></font></td>
		<td>
			<input name="httpd.ssl.org_name" size="15" maxlength="20" value="<% cfg_print_param httpd.ssl.org_name %>">
		</td>
	</tr>
	<tr id="ssl_orgunit">
		<td><font size=2><b>Organisation Unit Name</b></font></td>
		<td>
			<input name="httpd.ssl.org_unit" size="15" maxlength="20" value="<% cfg_print_param httpd.ssl.org_unit %>">
        </td>
	</tr>
	<tr id="ssl_email">
		<td><font size=2><b>Email Address</b></font></td>
		<td>
			<input name="httpd.ssl.email" size="15" maxlength="40" value="<% cfg_print_param httpd.ssl.email %>">
        </td>
	</tr>
	<tr id="ssl_cname">
		<td><font size=2><b>Common Name</b></font></td>
		<td>
		 	<input name="httpd.ssl.common_name" size="15" maxlength="64" value="<% cfg_print_param httpd.ssl.common_name %>">
		</td>
	</tr>
	<tr id="ssl_regen">
		<td><font size=2><b>Regenerate SSL Certificate</b></font></td>
		<td>
			<% form_print_radio httpd.ssl.regen_cert Yes No %>
		</td>
	</tr>
</table>

<table id="t6" cellspacing=5 width="510px"> 
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>TIME SETTINGS</b><br></td>
	</tr>
	<!--
	<tr>
		<td><font size=2><b>RTC</b></font></td>
	        <td>
			<select size="1" name="rtc.rtc.enabled">
				<option value="true" <% if cfg_string_compare rtc.rtc.enabled true ; then echo -n "selected"; fi %>>enabled</option>
				<option value="false" <% if cfg_string_compare rtc.rtc.enabled false ; then echo -n "selected"; fi %>>disabled</option>
			</select>
		</td>
	</tr>
	-->
	<tr id="ntp_servers1">
		<td><font size=2><b>NTP Server 1</b></font></td>
		<td>
			<input name="ntp.source.server1" size="20" value="<% cfg_print_param ntp.source.server1 %>">
		</td>
	</tr>
	<tr id="ntp_servers2">
		<td><font size=2><b>NTP Server 2</b></font></td>
		<td>
			<input name="ntp.source.server2" size="20" value="<% cfg_print_param ntp.source.server2 %>">
		</td>
	</tr>
	<tr id="ntp_servers3">
		<td><font size=2><b>NTP Server 3</b></font></td>
		<td>
			<input name="ntp.source.server3" size="20" value="<% cfg_print_param ntp.source.server3 %>">
		</td>
	</tr>
</table>

<table id="t7" cellspacing=5 width="510px"> 
	<col style="width:120px">                                                
	<col style="width:480px">                                   
	<tr>
		<td colspan="2"><br><b>SNMP SETTINGS</b><br></td>
	</tr>
	<tr>
		<td><font size=2><b>Enable SNMP</b></font></td>
        <td><font size=2>
        	<input type="radio" name="snmp.main.enabled"
        		value="on"
       <% if cfg_string_compare snmp.main.enabled on ; then echo -n "checked"; fi %>>Enable
       		<input type="radio" name="snmp.main.enabled"
        		value="off"
       <% if ! cfg_string_compare snmp.main.enabled on ; then echo -n "checked"; fi %>>Disable
		</font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>SNMP port</b></font></td>
		<td>
			<input name="snmp.main.port" size="5" maxlength=5 
			value="<% cfg_print_param snmp.main.port %>" 
			onchange="checkIntInputValue(this,1,65535,161);">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>sysContact</b></font></td>
		<td>
			<input name="snmp.system.syscontact" size="20" maxlength=50 value="<% cfg_print_param snmp.system.syscontact %>">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>sysName</b></font></td>
		<td>
			<input name="snmp.system.sysname" size="20" maxlength=50 value="<% cfg_print_param snmp.system.sysname %>">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>sysLocation</b></font></td>
		<td>
			<input name="snmp.system.syslocation" size="20" maxlength=50 value="<% cfg_print_param snmp.system.syslocation %>">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Read Only Community</b></font></td>
		<td>
			<input name="snmp.security.ro_community" size="20" maxlength=50 value="<% cfg_print_param snmp.security.ro_community %>">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Read/Write Community</b></font></td>
		<td>
			<input name="snmp.security.rw_community" size="20" maxlength=50 value="<% cfg_print_param snmp.security.rw_community %>">
		</td>
	</tr>
</table>

<table id="t8" cellspacing=5 width="510px"> 
	<col style="width:120px">                                                
	<col style="width:480px">                                   
	<tr>
		<td colspan="2"><br><b>I/O CONTROL SETTINGS</b><br></td>
	</tr>
	<tr>
		<td><font size=2><b>Enable TCP-to-Serial Tunnel</b></font></td>
        <td><font size=2>
        	<input type="radio" name="io-tunnel.application.enabled"
        		value="true"
       <% if cfg_string_compare io-tunnel.application.enabled true ; then echo -n "checked"; fi %>>Enable
       		<input type="radio" name="io-tunnel.application.enabled"
        		value="false"
       <% if ! cfg_string_compare io-tunnel.application.enabled true ; then echo -n "checked"; fi %>>Disable
		</font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>TCP Tunnel Mode</b></font></td>
        <td><font size=2>
        	<select size="1" width="140px" id="tcp_mode" name="io-tunnel.application.mode" onchange="view_tcp_tunnel_settings(this.value)">
				<option value="SERVER" <% if cfg_string_compare io-tunnel.application.mode SERVER ; then echo -n "selected"; fi %>>Passive</option>
				<option value="CLIENT" <% if ! cfg_string_compare io-tunnel.application.mode SERVER ; then echo -n "selected"; fi %>>Active</option>
			</select>
		</font>
        </td>
	</tr>
	<tr id=tcp_addr>
		<td><font size=2><b>TCP Control IP Address</b></font></td>
		<td>
			<input name="io-tunnel.application.ip" size="15" maxlength=15 
			value="<% cfg_print_param io-tunnel.application.ip %>" 
			onchange="IPAddrCheck(this,1)">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>TCP Control Port</b></font></td>
		<td>
			<input name="io-tunnel.application.port" size="5" maxlength=5 
			value="<% cfg_print_param io-tunnel.application.port %>" 
			onchange="checkIntInputValue(this,1,65535,12301);">
		</td>
	</tr>
	
	
	<tr>
		<td colspan="2"><br><b>Serial Port Settings</b><br></td>
	</tr>
	<tr>
		<td><font size=2><b>Port Name</b></font></td>
		<td>
			<input name="io-tunnel.serial_params.port_name" size="20" maxlength=50 value="<% cfg_print_param io-tunnel.serial_params.port_name %>">
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Baud Rate</b></font></td>
		<td>
			<select size="1" width="140px" name="io-tunnel.serial_params.baud">
				<option value="9600" <% if cfg_string_compare io-tunnel.serial_params.baud 9600 ; then echo -n "selected"; fi %>>9600</option>
				<option value="19200" <% if cfg_string_compare io-tunnel.serial_params.baud 19200 ; then echo -n "selected"; fi %>>19200</option>
				<option value="38400" <% if cfg_string_compare io-tunnel.serial_params.baud 38400 ; then echo -n "selected"; fi %>>38400</option>
				<option value="57600" <% if cfg_string_compare io-tunnel.serial_params.baud 57600 ; then echo -n "selected"; fi %>>57600</option>
				<option value="115200" <% if cfg_string_compare io-tunnel.serial_params.baud 115200 ; then echo -n "selected"; fi %>>115200</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Data Bits</b></font></td>
		<td>
			<select size="1" width="140px" name="io-tunnel.serial_params.data_bits">
				<option value="6" <% if cfg_string_compare io-tunnel.serial_params.data_bits 6 ; then echo -n "selected"; fi %>>6</option>
				<option value="7" <% if cfg_string_compare io-tunnel.serial_params.data_bits 7 ; then echo -n "selected"; fi %>>7</option>
				<option value="8" <% if cfg_string_compare io-tunnel.serial_params.data_bits 8 ; then echo -n "selected"; fi %>>8</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Parity</b></font></td>
		<td>
			<select size="1" width="140px" name="io-tunnel.serial_params.parity">
				<option value="NONE" <% if cfg_string_compare io-tunnel.serial_params.parity NONE ; then echo -n "selected"; fi %>>None</option>
				<option value="ODD" <% if cfg_string_compare io-tunnel.serial_params.parity ODD ; then echo -n "selected"; fi %>>Odd</option>
				<option value="EVEN" <% if cfg_string_compare io-tunnel.serial_params.parity EVEN ; then echo -n "selected"; fi %>>Even</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Stop Bits</b></font></td>
		<td>
			<select size="1" width="140px" name="io-tunnel.serial_params.stop_bits">
				<option value="1" <% if cfg_string_compare io-tunnel.serial_params.stop_bits 1 ; then echo -n "selected"; fi %>>1</option>
				<option value="2" <% if cfg_string_compare io-tunnel.serial_params.stop_bits 2 ; then echo -n "selected"; fi %>>2</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><font size=2><b>Flow Control</b></font></td>
		<td>
			<select size="1" width="140px" name="io-tunnel.serial_params.flow_control">
				<option value="OFF" <% if cfg_string_compare io-tunnel.serial_params.flow_control OFF ; then echo -n "selected"; fi %>>Off</option>
				<option value="HW" <% if cfg_string_compare io-tunnel.serial_params.flow_control HW ; then echo -n "selected"; fi %>>HW</option>
				<option value="XONXOFF" <% if cfg_string_compare io-tunnel.serial_params.flow_control 8 ; then echo -n "selected"; fi %>>Xon/Xoff</option>
			</select>
		</td>
	</tr>
</table>

<table id="t9" cellspacing=5 width="510px">
        <col style="width:120px">                                                
        <col style="width:480px"> 
	<tr>
		<td colspan="2"><br><b>SECURITY SETTINGS</b></td>
	<tr>
		<td>Reboot Function
		<td><% form_print_radio security.reset.enabled Enabled Disabled %>
	<tr>
		<td>Reset Factory Defaults
		<td><% form_print_radio security.defaults.enabled Enabled Disabled %>
	<tr>
		<td>Update Function
		<td><% form_print_radio security.update.enabled Enabled Disabled %>
		
<%
if cfg_string_compare httpd.webserver.password_set "true" ; then
      echo -n "
        <tr> 
	        <td><font size=2><b>Change Password</b></font></td>
		<td>
			<input name='pwd_old' type=password size='20' maxlength='50' placeholder='Old Password'>
			<input name='pwd_new' id='pwd_set' type=password size='20' maxlength='50' placeholder='New Password'>
			<input id='pwd_chk' type=password size='20' maxlength='50' placeholder='Confirm Password'>
		 </td>
	       "
else
      echo -n "
    <tr>
		<td><font size=2><b>Web UI Password</b></font></td>
		<td>
			<input name='pwd_set' id='pwd_set' type=password size='20' maxlength='50' placeholder='Password'>
			<input id='pwd_chk' type=password size='20' maxlength='50' placeholder='Confirm Password'>
		</td>
	       "
fi
%>
	<tr>
		<td colspan="2"><hr size="1" noshade></td>
     </tr>   
	<tr>
		<td colspan="2">
		<input type=submit value="Submit" formtarget="_self" onClick="return validatePassword();"><input type=reset value="Cancel">
        </td>
    </tr>
</table>



</form>
</body>
</html>
