<% . /usr/local/lib/cgi/haserl.sh ; check_instances uidefaults.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/config.sh %>
<%
function print_media_options()
{
# detect SD card, assuming it is always one, and with one partition, 
# and possibly multiple usb sticks with multiple partitions

    MEDIA_DIR=$(cat /etc/ferdinand.conf | sed -n -e "s/^storage_media=//p")
    DISK_SIZES=$(lsblk -o KNAME,SIZE)
    NUM_DISKS=$(lsblk -o name | grep -c -e '-sd')
    MOUNT_POINTS=$(lsblk -o KNAME,MOUNTPOINT)
	
    for disk in /sys/block/* ;do
        is_usb=0
        udev_name=$(basename $disk)
        if  [ -f $disk/removable ] && [ $(<$disk/removable) -gt 0 ] 
        then
        	is_usb=1
        else
# 		some USB chipsets do not report the removable bit, check with udevadm       	
        	if udevadm info --query=all --name="$udev_name" | grep ID_BUS | grep -Fxiq usb
        	then 
        		is_usb=1
        	fi
        fi
        if [ "$is_usb" -gt 0 ] && [ -f $disk/size ] && [ $(<$disk/size) -gt 0 ]
        then
# find usb stick partitions
            for syspart in $disk/sd* ; do
                part=$(basename $syspart)
                dev_name="/dev/$part"
                echo "<option value=$dev_name>USB stick ("
                echo "$DISK_SIZES" | grep -i "$part" | awk '{print $2;}' 
                if mount | grep -Fq "$dev_name" 
                then
                    if [ "$NUM_DISKS" -gt 1 ]
                    then
                        echo ", "
                        echo "$MOUNT_POINTS" | grep -i "$part" | awk '{print $2;}'                        
                    else
                        echo ", mounted"
                    fi
                    if mount | grep "$dev_name" | grep -Fq "$MEDIA_DIR" 
                    then
                        echo ", in use"
                    fi
                else
                    echo ", not mounted"
                fi
                echo ")</option>"
            done
        else
            if echo "$disk" | grep -Fq "mmcblk0"
            then 
# we assume the SD card has only one partition
                dev_name="/dev/mmcblk0p1" 
                echo "<option value=$dev_name selected>SD Card ("
                lsblk -o KNAME,SIZE | grep -i "mmcblk0p1" | awk '{print $2;}' 
                if mount | grep -Fq "$dev_name" 
                then
                    echo ", mounted"
                    if mount | grep "$dev_name" | grep -Fq "$MEDIA_DIR" 
                    then
                        echo ", in use"
                    fi
                else
                    echo ", not mounted"
                fi
                echo ")</option>"
            fi
        fi
    done
}
%>
<html>
<head>
<link href="/sys/css/basic.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
td.wrn {
    width:480px; 
    border:2px solid red;
    background-color: #ffff77;
    font-size: 12px;
    font-weight: bold;
}
img.cmd {
  width: 0px;
  height: 0px;
  visibility: hidden;
}
-->
</style>

<script type="text/javascript">
function autoresize(id) {
    var autoheight=300;
    if (document.getElementById){
        autoheight=document.getElementById(id).contentWindow.document .body.scrollHeight;
    }
    document.getElementById(id).height= (autoheight) + 30 + "px";
}
function required() {
	var fn = document.getElementById('filename').value;
    
	if(fn=="") {
		alert("Please select a file to upload.");
		return false;
        }
	return true;
};


</script>
</head> 
<body>
<br>
<b>FACTORY DEFAULTS</b><p>

<%
# first handle if return page is not set
if [ "$FORM_return_page"X = "X" ] ; then FORM_return_page="/index.html"; 
fi

if [ "$FORM_confirm"X = "true"X ] ; then 
	rv=`/sbin/uci get security.defaults.enabled`
	if [[ $rv == "true" ]] ; then
		cfg_restore_soft_defaults	

		echo '
<p>Settings successfully reverted to factory defaults.<p>
	'
	fi
else
	echo -n '
<div id=non_format>
<p>Reverts all settings <!--except "Network configuration"--> to factory defaults.
<form action="'
	echo -n $SCRIPT_NAME
	echo '" method="get">
<input type="hidden" name="confirm" value="true">
  <tr>
	<input type=submit value=" Reset Factory Defaults " '
		if [ "$(/sbin/uci -q get security.defaults.enabled)" == "false" ] ; then echo "disabled"; fi
	echo -n '
	> 
  </tr>
</form>

<p>Manage device configuration.</p>
<tr>
	<td>
		<form action=download_config.cgi method="get">
			<input type=submit value="Download device config ">
		</form>
	</td>
</tr>
</div>
'
fi
%>
</body>
</html>

